﻿using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace Custom_Connection_Appearance
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        
        }

        private void connection_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            RadDiagramConnection connection = (RadDiagramConnection) sender;

            if (connection.Source != null)
            {
                Point startPoint = connection.StartPoint;
                Point endPoint = connection.EndPoint;

                var angle = GetAngleOfLineBetweenTwoPoints(startPoint, endPoint);
                RotateTransform rotate = new RotateTransform();
                rotate.Angle = angle;
                rect.LayoutTransform = rotate;
                rect.Width = GetDistanceBetweenTwoPoints(startPoint, endPoint) * 0.8;
            }                
        }

        public static double GetDistanceBetweenTwoPoints(Point p1, Point p2)
        {
            double xDiff = Math.Pow(p2.X - p1.X, 2);
            double yDiff = Math.Pow(p2.Y - p1.Y, 2);
            return Math.Sqrt(xDiff + yDiff);
        }

        public static double GetAngleOfLineBetweenTwoPoints(Point p1, Point p2)
        {
            double xDiff = p2.X - p1.X;
            double yDiff = p2.Y - p1.Y;
            return Math.Atan2(yDiff, xDiff) * (180 / Math.PI);
        }
    }
}
